=begin
#-----------------------------------------------------------------------
Creative Commons (cc) Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)
you are free to:
Share — copy and redistribute the material in any medium or format
Adapt — remix, transform, and build upon the material
for any purpose, even commercially.
The licensor cannot revoke these freedoms as long as you follow the license terms.
Under the following terms:
Attribution — You must give appropriate credit, provide a link to the license, and indicate if changes were made. You may do so in any reasonable manner, but not in any way that suggests the licensor endorses you or your use.
ShareAlike — If you remix, transform, or build upon the material, you must distribute your contributions under the same license as the original.
No additional restrictions — You may not apply legal terms or technological measures that legally restrict others from doing anything the license permits.
Name :  	Vico-Section
Inspiration : 
Author :	Vincent Courteaux vico@regard.org
Usage : 	Met tout les groupe dont le nom commence par ifc... dans le calque corespondant ex( un groupe ayant pour nom ifcspace iras dans le calque C-space.
        	
        	
History: 1.0 	First release. 20161009
		 1.1	Add a Modification to the componement origine so they can be replace easyer	20161102
		 1.2 	Make the Origine modification independant & Speed improvement (was very long on large model...) 20161108
		
      
#-----------------------------------------------------------------------
=end

require 'sketchup.rb'
require 'extensions.rb'

###


module VicoIFC

 #=======================================================================# menu


  unless file_loaded?( File.basename(__FILE__) )
    parent_menu = ($tt_menu) ? $tt_menu : UI.menu('Plugins')
    parent_menu = parent_menu.add_submenu('VICO IFC')
    parent_menu.add_item("IFC to Layer")  {VicoIFC.all_ifc_to_layer}
	parent_menu.add_item("Change Selction Orgine to center bounds")  {VicoIFC.Origin_modification}
    parent_menu.add_item("Merge definition - Not working Yet")  {VicoIFC.merge_def}
  end


  def self.Origin_modification
			model = Sketchup.active_model
			sel = model.selection
			instances = sel.find_all{ |e| e.kind_of?(Sketchup::ComponentInstance) }
      			if instances.empty?
        			UI.messagebox('Selectionnez un composants.')
        		return
      			end
    		comps = instances.map{ |i| i.definition }
    		model.start_operation('Changement des Origines')
			comps.each {|d| bb = d.bounds
							origin = bb.center
							t = Geom::Transformation.new( origin )
    						d.entities.transform_entities( t.inverse, d.entities.to_a )
    						d.instances.each { |j|	j.transformation = j.transformation * t }
    					}
    		model.commit_operation					
    end
	
	
	def self.merge_def
		model = Sketchup.active_model
    
    if model.selection.empty?
      result = UI.messagebox(
        'Analyser toutes les definitions dans un model peu être long.' <<
        'Voulez vous continuer?', MB_YESNO)
      return if result == 7
      comps = model.definitions.select{ |e| !e.group? && !e.image? }
    else
      instances = model.entities.select{ |e| e.is_a?(Sketchup::ComponentInstance) }
      if instances.empty?
        UI.messagebox('Selectionnez un composants.')
        return
      end
      comps = instances.map{ |i| i.definition }
    end
    
    stack = model.definitions.select { |d| d.instances.length > 0 }
    model.start_operation('Replace equals Components')
    
    # Iterate all the component definitions collected and compare them against
    # the rest of the model.
    # When a match it found, replace all the instances.
    time_start = Time.now
    count = 0
    until comps.empty?
      proto = comps.shift
      
      # Avoid processing definitions that has already been replaced.
      next if proto.instances.empty?
      
      for d in stack.clone
        # Don't compare against self.
        next if proto == d
        
        # Don't compare against unused definitions.
        if d.instances.empty?
          stack.delete(d)
          next
        end
        
        #difference = VicoIFC.compo_Indent(proto,d)
       if proto.instances[0].equals?(d.instances[0])
        
        # Replace instances
        	for i in d.instances
          		i.definition = proto
 #         		i.transformation = i.transformation * difference
        	end
        end
        
        stack.delete(d)
        count += 1
      end
	end
	model.commit_operation
    
    UI.messagebox("#{count} definitions replaced. It took: #{Time.now - time_start}")
	end	
	
	
	
	def self.all_ifc_to_layer
		model = Sketchup.active_model
		layers = model.layers
		model.start_operation("IFC to Layer")
		model.definitions.each{|d| 
				next if d.image?
				next if d.group?	
				ifc_types = d.attribute_dictionaries["AppliedSchemaTypes"]				
				if ifc_types
					ifc_type = ifc_types["IFC 2x3"]
					layer_name = case ifc_type
					when "IfcWall" then "C-Murs"
					when "IfcWallStandardCase" then "C-Murs"
					when "IfcDoor" then "C-Men interieure"
					when "IfcSpace" then "I-Space"
					when "IfcSlab" then "C-Dalle"
					when "IfcCurtainWall" then "C-Men exterieure"
					when "IfcWindow" then "C-Men exterieure"
					when "IfcBuildingElementProxy" then "C-Divers"
					when "IfcFurnishingElement" then "C-Mobilier"
					when "IfcStair" then "C-Murs"
					when "IfcBuildingStorey" then "B-"
					else "layer0"
					end
					
					next if layer_name == "layer0" 
					if layer_name == "B-"
						d.instances.each{|i| etage = i.name[20..21] 
							layer_etage = layer_name + etage 
							new_layer = layers.add layer_etage
							i.layer = new_layer	}
					else
						new_layer = layers.add layer_name
						d.instances.each{|i| 
						i.layer = new_layer	}
					end
				end
				
				}	
		model.definitions.purge_unused
		model.commit_operation
			
	end
	
	
end  ## module VICO


#-----------------------------------------------------------------------------
file_loaded( File.basename(__FILE__) )
#-----------------------------------------------------------------------------